create.file.for.bayesx <- function(directory,
                                   sim.name,
                                   data.name,
                                   distr.name,
                                   equation.names,
                                   response.name,
                                   form.names,
                                   seed,
                                   iterations = 12000,
                                   burnin = 2000,
                                   step = 10,
                                   predict = FALSE,
                                   getsample = FALSE)
{
  logop <- paste("logopen using ", directory, sim.name, "_log.txt\n", sep = "")
  datop <- paste("dataset d\n", "d.infile using ", directory, data.name, ".raw\n", sep = "")
  defreg <- paste("mcmcreg yreg\n")
  
  pred.text <- ""
  
  equations <- ""
  for(i in 1:length(equation.names)){
    if (i == 1) {
      if (predict && i == length(equation.names)) {
        pred.text <- " predict=fulls"
      }
      equations <- paste(equations, "yreg.outfile = ", sim.name, "_", equation.names[i], "\n", sep = "")
      equations <- paste(equations, "yreg.hregress ", response.name[i], "=", form.names[i],
                         ", family=", distr.name, 
                         " equationtype=", equation.names[i],
                         " saveestimation",
                         " iterations=", iterations,
                         " burnin=", burnin,
                         " step=", step,
                         " setseed=", seed,
                         pred.text,
                         " using d\n", 
                         sep = "")
    } else {
      if (predict && i == length(equation.names)) {
        pred.text <- " predict=fulls"
      }
      equations <- paste(equations, "yreg.outfile = ", sim.name, "_", equation.names[i], "\n", sep = "")
      equations <- paste(equations, "yreg.hregress ", response.name[i], "=", form.names[i],
                         ", family=", distr.name, 
                         " equationtype=", equation.names[i],
                         " setseed=", seed,
                         pred.text,
                         " using d\n",
                         sep = "")
    }
  }
  getsam <- "\n"
  if(getsample){
    getsam <- paste("yreg.getsample\n")
  }
  end <- paste("drop d\n", "drop yreg\n", "logclose\n", "exit\n", sep = "")
  
  all <- paste(logop, datop, defreg, equations, getsam, end, sep = "")
  
  filename <-  paste(sim.name, ".txt", sep = "")
  write(all, file = filename)
  return(filename)
}