skewness <- c("0", "2", "4", "8")
alphas <- c(0, 2, 4, 8)

da <- data.frame(c0 = rep(0, 1000), c2 = rep(0, 1000), c4 = rep(0, 1000), c8 = rep(0, 1000))
da.bias <- da
da.mse <- da

pdf(file = "alphas.pdf", width = 12, height = 12)

par(mfrow = c(2,2))

for (i in 1:length(skewness)) {
  s <- skewness[i]
  al <- l.alpha[[paste("S3_N_", s, "_sn", sep = "")]]
  plot(al$pmean, xlab = "", ylab = "", main = paste("alpha", s))
  abline(h = alphas[i], col = "red")
  da[,i] <- al$pmean
  da.bias[,i] <- al$pmean - alphas[i]
  da.mse[,i] <- (al$pmean - alphas[i])^2
}

dev.off()


pdf(file = "sim_s3_12_alphas.pdf", width = 7, height = 5)
par(mfrow = c(1,2))
boxplot(da.bias, xlab = expression(alpha), names = c(0, 2, 4, 8), main = "Bias")
boxplot(log(da.mse), xlab = expression(alpha), names = c(0, 2, 4, 8), main = "log(MSE)")
dev.off()
