skewness <- c("0", "2", "4", "8")
methods <- c("n", "sn")

pdf("waic_dic_plot.pdf", width = 15, height = 10)
par(mfrow = c(2,3))
for (i in 1:length(skewness)) {
  s <- skewness[i]
  
  plot(1:1000, 1:1000, ylim = c(2800, 3100), xlab = "", ylab = "", main = paste("WAIC", s))
  for (i in 1:length(methods)) {
    waic <- l.waic[[paste("S3_N_", s, "_", methods[i], sep = "")]]
    points(waic$waic, col = i)
  }
  legend(0, 3100, methods, col = 1:3, lty = 1)
  
  plot(1:1000, 1:1000, ylim = c(2600, 2900), xlab = "", ylab = "", main = paste("Predictive", s))
  for (i in 1:length(methods)) {
    waic <- l.waic[[paste("S3_N_", s, "_", methods[i], sep = "")]]
    points(waic$l_pd, col = i)
  }
  legend(0, 2900, methods, col = 1:3, lty = 1)

  plot(1:1000, 1:1000, ylim = c(80, 125), xlab = "", ylab = "", main = paste("WAIC PD", s), col = "white")
  for (i in 1:length(methods)) {
    waic <- l.waic[[paste("S3_N_", s, "_", methods[i], sep = "")]]
    points(waic$p_d, col = i)
  }
  legend(0, 90, methods, col = 1:3, lty = 1)
  
  
  plot(1:1000, 1:1000, ylim = c(2850, 3100), xlab = "", ylab = "", main = paste("DIC", s))
  for (i in 1:length(methods)) {
    dic <- l.dic[[paste("S3_N_", s, "_", methods[i], sep = "")]]
    points(dic$dic, col = i)
  }
  legend(0, 3100, methods, col = 1:3, lty = 1)
  
  plot(1:1000, 1:1000, ylim = c(2550, 2900), xlab = "", ylab = "", main = paste("Deviance", s))
  for (i in 1:length(methods)) {
    dic <- l.dic[[paste("S3_N_", s, "_", methods[i], sep = "")]]
    points(dic$deviance, col = i)
  }
  legend(0, 2900, methods, col = 1:3, lty = 1)
  
  plot(1:1000, 1:1000, ylim = c(90, 120), xlab = "", ylab = "", main = paste("DIC PD", s), col = "white")
  for (i in 1:length(methods)) {
    dic <- l.dic[[paste("S3_N_", s, "_", methods[i], sep = "")]]
    points(dic$pd, col = i)
  }
  legend(0, 100, methods, col = 1:3, lty = 1)
}
dev.off()