//------------------------------------------------------------------------------
//-------------- CLASS: DISTR_bivst_df --------------------------------------
//------------------------------------------------------------------------------


class __EXPORT_TYPE DISTR_bivst_df : public DISTR_gamlss
{

protected:
    unsigned pos;

    void set_worklin(void);
    void modify_worklin(void);

public:
    datamatrix response2;
    double * response2p;
    double ef[701];
    double iota[1][1] = 0.0;

    // DEFAULT CONSTRUCTOR

    DISTR_bivst_df(void) : DISTR_gamlss()
    {
    }

    // CONSTRUCTOR

    DISTR_bivst_df(GENERAL_OPTIONS * o, const datamatrix & r, unsigned & p,
                      const datamatrix & w=datamatrix());

    // COPY CONSTRUCTOR

    DISTR_bivst_df(const DISTR_bivst_df & nd);

    // OVERLOADED ASSIGNMENT OPERATOR

    const DISTR_bivst_df & operator=(const DISTR_bivst_df & nd);

    // DESTRUCTOR

    ~DISTR_bivst_df() {}

    double get_intercept_start(void);

    void compute_param_mult(vector<double *>  linpred,double * param);

    double loglikelihood_weightsone(double * response, double * linpred);

    void compute_iwls_wweightschange_weightsone(double * response,
                                                double * linpred,
                                                double * workingweight,
                                                double * workingresponse,
                                                double & like,
                                                const bool & compute_like);


    void outoptions(void);

    void update_end(void);

};


//------------------------------------------------------------------------------
//-------------- CLASS: DISTR_bivst_alpha --------------------------------------
//------------------------------------------------------------------------------


class __EXPORT_TYPE DISTR_bivst_alpha : public DISTR_gamlss
{

protected:
    unsigned pos;

    void set_worklin(void);
    void modify_worklin(void);

public:
    datamatrix response2;
    double * response2p;
    double ef[19][11][11][35];

    // DEFAULT CONSTRUCTOR

    DISTR_bivst_alpha(void) : DISTR_gamlss()
    {
    }

    // CONSTRUCTOR

    DISTR_bivst_alpha(GENERAL_OPTIONS * o, const datamatrix & r, unsigned & p,
                      const datamatrix & w=datamatrix());

    // COPY CONSTRUCTOR

    DISTR_bivst_alpha(const DISTR_bivst_alpha & nd);

    // OVERLOADED ASSIGNMENT OPERATOR

    const DISTR_bivst_alpha & operator=(const DISTR_bivst_alpha & nd);

    // DESTRUCTOR

    ~DISTR_bivst_alpha() {}

    double get_intercept_start(void);

    void compute_param_mult(vector<double *>  linpred,double * param);

    double loglikelihood_weightsone(double * response, double * linpred);

    void compute_iwls_wweightschange_weightsone(double * response,
                                                double * linpred,
                                                double * workingweight,
                                                double * workingresponse,
                                                double & like,
                                                const bool & compute_like);


    void outoptions(void);

    void update_end(void);

};

//------------------------------------------------------------------------------
//-------------- CLASS: DISTR_bivst_rho ----------------------------------------
//------------------------------------------------------------------------------


class __EXPORT_TYPE DISTR_bivst_rho : public DISTR_gamlss
{

protected:
    void set_worklin(void);
    void modify_worklin(void);

public:
    datamatrix response2;
    double * response2p;
    double ef[19][11][11][35];

    // DEFAULT CONSTRUCTOR

    DISTR_bivst_rho(void) : DISTR_gamlss()
    {
    }

    // CONSTRUCTOR

    DISTR_bivst_rho(GENERAL_OPTIONS * o, const datamatrix & r,
                    const datamatrix & w=datamatrix());

    // COPY CONSTRUCTOR

    DISTR_bivst_rho(const DISTR_bivst_rho & nd);

    // OVERLOADED ASSIGNMENT OPERATOR

    const DISTR_bivst_rho & operator=(const DISTR_bivst_rho & nd);

    // DESTRUCTOR

    ~DISTR_bivst_rho() {}

    double get_intercept_start(void);

    void compute_param_mult(vector<double *>  linpred,double * param);

    double loglikelihood_weightsone(double * response, double * linpred);

    void compute_iwls_wweightschange_weightsone(double * response,
                                                double * linpred,
                                                double * workingweight,
                                                double * workingresponse,
                                                double & like,
                                                const bool & compute_like);


    void outoptions(void);

    void update_end(void);

};

//------------------------------------------------------------------------------
//-------------- CLASS: DISTR_bivst_omega --------------------------------------
//------------------------------------------------------------------------------


class __EXPORT_TYPE DISTR_bivst_omega : public DISTR_gamlss
{

protected:
    unsigned pos;

    void set_worklin(void);
    void modify_worklin(void);

public:
    datamatrix response2;
    double * response2p;
    double ef[19][11][11][35];

    // DEFAULT CONSTRUCTOR

    DISTR_bivst_omega(void) : DISTR_gamlss()
    {
    }

    // CONSTRUCTOR

    DISTR_bivst_omega(GENERAL_OPTIONS * o, const datamatrix & r, unsigned & p,
                      const datamatrix & w=datamatrix());

    // COPY CONSTRUCTOR

    DISTR_bivst_omega(const DISTR_bivst_omega & nd);

    // OVERLOADED ASSIGNMENT OPERATOR

    const DISTR_bivst_omega & operator=(const DISTR_bivst_omega & nd);

    // DESTRUCTOR

    ~DISTR_bivst_omega() {}

    double get_intercept_start(void);

    void compute_param_mult(vector<double *>  linpred,double * param);

    double loglikelihood_weightsone(double * response, double * linpred);

    void compute_iwls_wweightschange_weightsone(double * response,
                                                double * linpred,
                                                double * workingweight,
                                                double * workingresponse,
                                                double & like,
                                                const bool & compute_like);


    void outoptions(void);

    void update_end(void);

};

//------------------------------------------------------------------------------
//-------------- CLASS: DISTR_bivst_xi -----------------------------------------
//------------------------------------------------------------------------------

class __EXPORT_TYPE DISTR_bivst_xi : public DISTR_gamlss
{

protected:
    unsigned pos;

    void set_worklin(void);
    void modify_worklin(void);

public:
    datamatrix response2;
    double * response2p;
    double ef[19][11][11][35];

    // ONLY FOR THE MAIN PARAMETER:
    void check_errors(void);

    // DEFAULT CONSTRUCTOR
    DISTR_bivst_xi(void) : DISTR_gamlss()
    {
    }

    // CONSTRUCTOR

    DISTR_bivst_xi(GENERAL_OPTIONS * o, const datamatrix & r, unsigned & p,
                   const datamatrix & w=datamatrix());

    // COPY CONSTRUCTOR

    DISTR_bivst_xi(const DISTR_bivst_xi & nd);

    // OVERLOADED ASSIGNMENT OPERATOR

    const DISTR_bivst_xi & operator=(const DISTR_bivst_xi & nd);

    // DESTRUCTOR

    ~DISTR_bivst_xi() {}


    // ONLY FOR THE MAIN PARAMETER:

    void compute_deviance_mult(vector<double *> response,
                               vector<double *> weight,
                               vector<double *> linpred,
                               double * deviance,
                               vector<datamatrix*> aux);



    double get_intercept_start(void);

    void compute_param_mult(vector<double *>  linpred,double * param);

    // ONLY FOR THE MAIN PARAMETER:

    double cdf_mult(vector<double *> response,
                    vector<double *> param,
                    vector<double *> weight,
                    vector<datamatrix *> aux);


    // ONLY FOR THE MAIN PARAMETER:

    double pdf_mult(vector<double *> response,
                    vector<double *> param,
                    vector<double *> weight,
                    vector<datamatrix *> aux);


    double loglikelihood_weightsone(double * response, double * linpred);

    void compute_iwls_wweightschange_weightsone(double * response,
                                                double * linpred,
                                                double * workingweight,
                                                double * workingresponse,
                                                double & like,
                                                const bool & compute_like);


    // ONLY FOR THE MAIN PARAMETER:

    void compute_mu_mult(vector<double *> linpred,vector<double *> response,double * mu);


    void outoptions(void);

    void update_end(void);

};
