/* BayesX - Software for Bayesian Inference in
Structured Additive Regression Models.
Copyright (C) 2011  Christiane Belitz, Andreas Brezger,
Thomas Kneib, Stefan Lang, Nikolaus Umlauf

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA. */

#include"func_sn.h"

namespace supportfunctions
{
  double sn_a0(double al){
    double a = al * 0.96;
    return 2/PI/sqrt(1 + 8*a*a/PI/PI);
  }

  double sn_a1(double al){
    double a = al;
    double b = 2/PI;
    return - 0.975 * pow(sqrt(b),3)*a/pow(sqrt(1 + 8*a*a / (PI*PI)),3) / sqrt(1 + a*a/(1 + 8*a*a/(PI*PI)));
  }

  double sn_a2(double al){
    double a = al * 0.96;
    return 2/PI/pow(sqrt(1 + 8*a*a/PI/PI), 3);
  }
}
